/*
	This file contains the entry point (Reset_Handler) of your firmware project.
	The reset handled initializes the RAM and calls system library initializers as well as
	the platform-specific initializer and the main() function.
*/

#include <stddef.h>
extern void *_estack;

void Reset_Handler();
void Default_Handler();

#ifdef DEBUG_DEFAULT_INTERRUPT_HANDLERS
void __attribute__ ((weak)) NMI_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void NMI_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) HardFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void HardFault_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) MemManage_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void MemManage_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) BusFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void BusFault_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) UsageFault_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UsageFault_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SVC_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SVC_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DebugMon_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DebugMon_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) PendSV_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void PendSV_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SysTick_Handler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SysTick_Handler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) WWDG1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void WWDG1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) PVD_AVD_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void PVD_AVD_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TAMP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TAMP_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RTC_WKUP_ALARM_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RTC_WKUP_ALARM_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RESERVED4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RESERVED4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RCC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RCC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream6_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream6_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ADC1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ADC1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FDCAN1_IT0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FDCAN1_IT0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FDCAN2_IT0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FDCAN2_IT0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FDCAN1_IT1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FDCAN1_IT1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FDCAN2_IT1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FDCAN2_IT1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM1_BRK_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM1_BRK_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM1_UP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM1_UP_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM1_TRG_COM_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM1_TRG_COM_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM1_CC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM1_CC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C1_EV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C1_EV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C1_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C1_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C2_EV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C2_EV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C2_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C2_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPI1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPI2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI10_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI10_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RTC_TIMESTAMP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RTC_TIMESTAMP_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI11_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI11_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM8_BRK_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM8_BRK_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM8_UP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM8_UP_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM8_TRG_COM_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM8_TRG_COM_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM8_CC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM8_CC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA1_Stream7_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA1_Stream7_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FMC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FMC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SDMMC1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SDMMC1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPI3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) UART4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UART4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) UART5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UART5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM6_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM6_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM7_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM7_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ETH1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ETH1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ETH1_WKUP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ETH1_WKUP_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FDCAN_CAL_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FDCAN_CAL_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI6_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI6_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI7_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI7_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI8_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI8_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI9_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI9_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream6_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream6_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMA2_Stream7_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMA2_Stream7_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USART6_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USART6_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C3_EV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C3_EV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C3_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C3_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USBH_OHCI_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USBH_OHCI_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) USBH_EHCI_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void USBH_EHCI_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI12_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI12_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI13_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI13_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DCMI_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DCMI_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) CRYP1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CRYP1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) HASH1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void HASH1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) FPU_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void FPU_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) UART7_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UART7_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) UART8_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void UART8_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPI4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPI5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPI6_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPI6_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SAI1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SAI1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LTDC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LTDC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LTDC_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LTDC_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ADC2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ADC2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SAI2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SAI2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) QUADSPI_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void QUADSPI_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LPTIM1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LPTIM1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) CEC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CEC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C4_EV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C4_EV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C4_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C4_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SPDIF_RX_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SPDIF_RX_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) OTG_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void OTG_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RESERVED99_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RESERVED99_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) IPCC_RX0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void IPCC_RX0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) IPCC_TX0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void IPCC_TX0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DMAMUX1_OVR_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DMAMUX1_OVR_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) IPCC_RX1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void IPCC_RX1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) IPCC_TX1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void IPCC_TX1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) CRYP2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void CRYP2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) HASH2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void HASH2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C5_EV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C5_EV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C5_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C5_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) GPU_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void GPU_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DFSDM1_FLT0_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DFSDM1_FLT0_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DFSDM1_FLT1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DFSDM1_FLT1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DFSDM1_FLT2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DFSDM1_FLT2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DFSDM1_FLT3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DFSDM1_FLT3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SAI3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SAI3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DFSDM1_FLT4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DFSDM1_FLT4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM15_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM15_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM16_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM16_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM17_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM17_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM12_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM12_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) MDIOS_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void MDIOS_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI14_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI14_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) MDMA_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void MDMA_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DSI_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DSI_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SDMMC2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SDMMC2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) HSEM_IT2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void HSEM_IT2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DFSDM1_FLT5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DFSDM1_FLT5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) EXTI15_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void EXTI15_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) nCTIIRQ1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void nCTIIRQ1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) nCTIIRQ2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void nCTIIRQ2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM13_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM13_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) TIM14_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void TIM14_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DAC_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DAC_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RNG1_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RNG1_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RNG2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RNG2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C6_EV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C6_EV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) I2C6_ER_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void I2C6_ER_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SDMMC3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SDMMC3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LPTIM2_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LPTIM2_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LPTIM3_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LPTIM3_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LPTIM4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LPTIM4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) LPTIM5_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void LPTIM5_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) ETH1_LPI_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void ETH1_LPI_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RESERVED143_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RESERVED143_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) MPU_SEV_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void MPU_SEV_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RCC_WAKEUP_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RCC_WAKEUP_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) SAI4_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void SAI4_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) DTS_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void DTS_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) RESERVED148_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void RESERVED148_IRQHandler();
	asm("bkpt 255");
}

void __attribute__ ((weak)) WAKEUP_PIN_IRQHandler() 
{
	//If you hit the breakpoint below, one of the interrupts was unhandled in your code. 
	//Define the following function in your code to handle it:
	//	extern "C" void WAKEUP_PIN_IRQHandler();
	asm("bkpt 255");
}

#else
void NMI_Handler()                __attribute__ ((weak, alias ("Default_Handler")));
void HardFault_Handler()          __attribute__ ((weak, alias ("Default_Handler")));
void MemManage_Handler()          __attribute__ ((weak, alias ("Default_Handler")));
void BusFault_Handler()           __attribute__ ((weak, alias ("Default_Handler")));
void UsageFault_Handler()         __attribute__ ((weak, alias ("Default_Handler")));
void SVC_Handler()                __attribute__ ((weak, alias ("Default_Handler")));
void DebugMon_Handler()           __attribute__ ((weak, alias ("Default_Handler")));
void PendSV_Handler()             __attribute__ ((weak, alias ("Default_Handler")));
void SysTick_Handler()            __attribute__ ((weak, alias ("Default_Handler")));
void WWDG1_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void PVD_AVD_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void TAMP_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void RTC_WKUP_ALARM_IRQHandler()  __attribute__ ((weak, alias ("Default_Handler")));
void RESERVED4_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void RCC_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void EXTI0_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI1_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI2_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI3_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI4_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream0_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream1_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream2_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream3_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream4_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream5_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream6_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void ADC1_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void FDCAN1_IT0_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void FDCAN2_IT0_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void FDCAN1_IT1_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void FDCAN2_IT1_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void EXTI5_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void TIM1_BRK_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void TIM1_UP_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void TIM1_TRG_COM_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void TIM1_CC_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void TIM2_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void TIM3_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void TIM4_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void I2C1_EV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C1_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C2_EV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C2_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SPI1_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void SPI2_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void USART1_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void USART2_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void USART3_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void EXTI10_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void RTC_TIMESTAMP_IRQHandler()   __attribute__ ((weak, alias ("Default_Handler")));
void EXTI11_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void TIM8_BRK_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void TIM8_UP_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void TIM8_TRG_COM_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void TIM8_CC_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void DMA1_Stream7_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void FMC_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void SDMMC1_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void TIM5_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void SPI3_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void UART4_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void UART5_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void TIM6_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void TIM7_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream0_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream1_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream2_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream3_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream4_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void ETH1_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void ETH1_WKUP_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void FDCAN_CAL_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void EXTI6_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI7_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI8_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI9_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream5_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream6_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void DMA2_Stream7_IRQHandler()    __attribute__ ((weak, alias ("Default_Handler")));
void USART6_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void I2C3_EV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C3_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void USBH_OHCI_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void USBH_EHCI_IRQHandler()       __attribute__ ((weak, alias ("Default_Handler")));
void EXTI12_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void EXTI13_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void DCMI_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void CRYP1_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void HASH1_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void FPU_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void UART7_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void UART8_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void SPI4_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void SPI5_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void SPI6_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void SAI1_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void LTDC_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void LTDC_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void ADC2_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void SAI2_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void QUADSPI_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void LPTIM1_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void CEC_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void I2C4_EV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C4_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SPDIF_RX_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void OTG_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void RESERVED99_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void IPCC_RX0_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void IPCC_TX0_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void DMAMUX1_OVR_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void IPCC_RX1_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void IPCC_TX1_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void CRYP2_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void HASH2_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void I2C5_EV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C5_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void GPU_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void DFSDM1_FLT0_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void DFSDM1_FLT1_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void DFSDM1_FLT2_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void DFSDM1_FLT3_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void SAI3_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void DFSDM1_FLT4_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void TIM15_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void TIM16_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void TIM17_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void TIM12_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void MDIOS_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void EXTI14_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void MDMA_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void DSI_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void SDMMC2_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void HSEM_IT2_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void DFSDM1_FLT5_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void EXTI15_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void nCTIIRQ1_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void nCTIIRQ2_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void TIM13_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void TIM14_IRQHandler()           __attribute__ ((weak, alias ("Default_Handler")));
void DAC_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void RNG1_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void RNG2_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void I2C6_EV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void I2C6_ER_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void SDMMC3_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void LPTIM2_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void LPTIM3_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void LPTIM4_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void LPTIM5_IRQHandler()          __attribute__ ((weak, alias ("Default_Handler")));
void ETH1_LPI_IRQHandler()        __attribute__ ((weak, alias ("Default_Handler")));
void RESERVED143_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void MPU_SEV_IRQHandler()         __attribute__ ((weak, alias ("Default_Handler")));
void RCC_WAKEUP_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
void SAI4_IRQHandler()            __attribute__ ((weak, alias ("Default_Handler")));
void DTS_IRQHandler()             __attribute__ ((weak, alias ("Default_Handler")));
void RESERVED148_IRQHandler()     __attribute__ ((weak, alias ("Default_Handler")));
void WAKEUP_PIN_IRQHandler()      __attribute__ ((weak, alias ("Default_Handler")));
#endif

void * g_pfnVectors[0xa6] __attribute__ ((section (".isr_vector"), used)) = 
{
	&_estack,
	&Reset_Handler,
	&NMI_Handler,
	&HardFault_Handler,
	&MemManage_Handler,
	&BusFault_Handler,
	&UsageFault_Handler,
	NULL,
	NULL,
	NULL,
	NULL,
	&SVC_Handler,
	&DebugMon_Handler,
	NULL,
	&PendSV_Handler,
	&SysTick_Handler,
	&WWDG1_IRQHandler,
	&PVD_AVD_IRQHandler,
	&TAMP_IRQHandler,
	&RTC_WKUP_ALARM_IRQHandler,
	&RESERVED4_IRQHandler,
	&RCC_IRQHandler,
	&EXTI0_IRQHandler,
	&EXTI1_IRQHandler,
	&EXTI2_IRQHandler,
	&EXTI3_IRQHandler,
	&EXTI4_IRQHandler,
	&DMA1_Stream0_IRQHandler,
	&DMA1_Stream1_IRQHandler,
	&DMA1_Stream2_IRQHandler,
	&DMA1_Stream3_IRQHandler,
	&DMA1_Stream4_IRQHandler,
	&DMA1_Stream5_IRQHandler,
	&DMA1_Stream6_IRQHandler,
	&ADC1_IRQHandler,
	&FDCAN1_IT0_IRQHandler,
	&FDCAN2_IT0_IRQHandler,
	&FDCAN1_IT1_IRQHandler,
	&FDCAN2_IT1_IRQHandler,
	&EXTI5_IRQHandler,
	&TIM1_BRK_IRQHandler,
	&TIM1_UP_IRQHandler,
	&TIM1_TRG_COM_IRQHandler,
	&TIM1_CC_IRQHandler,
	&TIM2_IRQHandler,
	&TIM3_IRQHandler,
	&TIM4_IRQHandler,
	&I2C1_EV_IRQHandler,
	&I2C1_ER_IRQHandler,
	&I2C2_EV_IRQHandler,
	&I2C2_ER_IRQHandler,
	&SPI1_IRQHandler,
	&SPI2_IRQHandler,
	&USART1_IRQHandler,
	&USART2_IRQHandler,
	&USART3_IRQHandler,
	&EXTI10_IRQHandler,
	&RTC_TIMESTAMP_IRQHandler,
	&EXTI11_IRQHandler,
	&TIM8_BRK_IRQHandler,
	&TIM8_UP_IRQHandler,
	&TIM8_TRG_COM_IRQHandler,
	&TIM8_CC_IRQHandler,
	&DMA1_Stream7_IRQHandler,
	&FMC_IRQHandler,
	&SDMMC1_IRQHandler,
	&TIM5_IRQHandler,
	&SPI3_IRQHandler,
	&UART4_IRQHandler,
	&UART5_IRQHandler,
	&TIM6_IRQHandler,
	&TIM7_IRQHandler,
	&DMA2_Stream0_IRQHandler,
	&DMA2_Stream1_IRQHandler,
	&DMA2_Stream2_IRQHandler,
	&DMA2_Stream3_IRQHandler,
	&DMA2_Stream4_IRQHandler,
	&ETH1_IRQHandler,
	&ETH1_WKUP_IRQHandler,
	&FDCAN_CAL_IRQHandler,
	&EXTI6_IRQHandler,
	&EXTI7_IRQHandler,
	&EXTI8_IRQHandler,
	&EXTI9_IRQHandler,
	&DMA2_Stream5_IRQHandler,
	&DMA2_Stream6_IRQHandler,
	&DMA2_Stream7_IRQHandler,
	&USART6_IRQHandler,
	&I2C3_EV_IRQHandler,
	&I2C3_ER_IRQHandler,
	&USBH_OHCI_IRQHandler,
	&USBH_EHCI_IRQHandler,
	&EXTI12_IRQHandler,
	&EXTI13_IRQHandler,
	&DCMI_IRQHandler,
	&CRYP1_IRQHandler,
	&HASH1_IRQHandler,
	&FPU_IRQHandler,
	&UART7_IRQHandler,
	&UART8_IRQHandler,
	&SPI4_IRQHandler,
	&SPI5_IRQHandler,
	&SPI6_IRQHandler,
	&SAI1_IRQHandler,
	&LTDC_IRQHandler,
	&LTDC_ER_IRQHandler,
	&ADC2_IRQHandler,
	&SAI2_IRQHandler,
	&QUADSPI_IRQHandler,
	&LPTIM1_IRQHandler,
	&CEC_IRQHandler,
	&I2C4_EV_IRQHandler,
	&I2C4_ER_IRQHandler,
	&SPDIF_RX_IRQHandler,
	&OTG_IRQHandler,
	&RESERVED99_IRQHandler,
	&IPCC_RX0_IRQHandler,
	&IPCC_TX0_IRQHandler,
	&DMAMUX1_OVR_IRQHandler,
	&IPCC_RX1_IRQHandler,
	&IPCC_TX1_IRQHandler,
	&CRYP2_IRQHandler,
	&HASH2_IRQHandler,
	&I2C5_EV_IRQHandler,
	&I2C5_ER_IRQHandler,
	&GPU_IRQHandler,
	&DFSDM1_FLT0_IRQHandler,
	&DFSDM1_FLT1_IRQHandler,
	&DFSDM1_FLT2_IRQHandler,
	&DFSDM1_FLT3_IRQHandler,
	&SAI3_IRQHandler,
	&DFSDM1_FLT4_IRQHandler,
	&TIM15_IRQHandler,
	&TIM16_IRQHandler,
	&TIM17_IRQHandler,
	&TIM12_IRQHandler,
	&MDIOS_IRQHandler,
	&EXTI14_IRQHandler,
	&MDMA_IRQHandler,
	&DSI_IRQHandler,
	&SDMMC2_IRQHandler,
	&HSEM_IT2_IRQHandler,
	&DFSDM1_FLT5_IRQHandler,
	&EXTI15_IRQHandler,
	&nCTIIRQ1_IRQHandler,
	&nCTIIRQ2_IRQHandler,
	&TIM13_IRQHandler,
	&TIM14_IRQHandler,
	&DAC_IRQHandler,
	&RNG1_IRQHandler,
	&RNG2_IRQHandler,
	&I2C6_EV_IRQHandler,
	&I2C6_ER_IRQHandler,
	&SDMMC3_IRQHandler,
	&LPTIM2_IRQHandler,
	&LPTIM3_IRQHandler,
	&LPTIM4_IRQHandler,
	&LPTIM5_IRQHandler,
	&ETH1_LPI_IRQHandler,
	&RESERVED143_IRQHandler,
	&MPU_SEV_IRQHandler,
	&RCC_WAKEUP_IRQHandler,
	&SAI4_IRQHandler,
	&DTS_IRQHandler,
	&RESERVED148_IRQHandler,
	&WAKEUP_PIN_IRQHandler,
};

void SystemInit();
void __libc_init_array();
int main();

extern void *_sidata, *_sdata, *_edata;
extern void *_sbss, *_ebss;

void __attribute__((naked, noreturn)) Reset_Handler()
{
	//Normally the CPU should will setup the based on the value from the first entry in the vector table.
	//If you encounter problems with accessing stack variables during initialization, ensure the line below is enabled.
	#if defined(sram_layout) || defined(INITIALIZE_SP_AT_RESET)
	asm ("ldr sp, =_estack");
	#endif

	void **pSource, **pDest;
	for (pSource = &_sidata, pDest = &_sdata; pDest != &_edata; pSource++, pDest++)
		*pDest = *pSource;

	for (pDest = &_sbss; pDest != &_ebss; pDest++)
		*pDest = 0;

	SystemInit();
	__libc_init_array();
	(void)main();
	for (;;) ;
}

void __attribute__((naked, noreturn)) Default_Handler()
{
	//If you get stuck here, your code is missing a handler for some interrupt.
	//Define a 'DEBUG_DEFAULT_INTERRUPT_HANDLERS' macro via VisualGDB Project Properties and rebuild your project.
	//This will pinpoint a specific missing vector.
	for (;;) ;
}
